/**	Project: A1
 *	File: ListArray.java
 *	Name: Justin Fiedler
 *	Login: fiedler
 */

public class ListArray implements ListInterface
{	private java.lang.Object[] list;
	private int count;
	
	/**
	 * Constructs a default ListArray by setting count = 0 and
	 * first = null.
	 */
	 
	public ListArray()
	{	list = new Object[10];
		count = 0;
	}
	
	/**
	 * Adds an object at the location given by position to the
	 * list, where the first item in the list is at position = 0.
	 */
	
	public void add(int position, java.lang.Object ob)
	{       if(position < 0 || position > count)
		{	throw new IndexOutOfBoundsException();
		}
		else
		{	if(arrayIsFull()) expandArray();
			for(int i = count; i > position; i--)
			{	list[i] = list[i-1];
			}
			list[position] = ob;
			count++;
		}
	}
	
	/**
	 *Adds an object to the end of the list.
	 */
	public void add(java.lang.Object ob)
	{       add(count, ob);
	}
	
	/**
	 * Returns the object at the given postion, where the first
	 * item in the list is at postion = 0.
	 */
	
	public java.lang.Object get(int position)
	{       if(position < 0 || position > count)
		{	throw new IndexOutOfBoundsException();	
		}
		return list[position];
	}
	
	/**
	 * Returns the object at position, after removing the object
	 * from the list.
	 */
	
	public java.lang.Object remove(int position)
	{       Object o = null;
		if(position >= 0 && position <= count)
		{	o = list[position];
			for(int i = position; i < count - 1; i++)
			{	list[i] = list[i + 1];
			}
		}
		else
		{       throw new IndexOutOfBoundsException();
		}
		count--;
		return o;
	}
	
	/**
	 * Returns the number of items currently in the list.			
	 */
	
	public int size()
	{       return count;
	}

	/**
	 *	Returns true is the array is full else false
	 */
	
	public boolean arrayIsFull()
	{	return count == list.length;
	}

	/**
	 *	Expands the list to twice the capacity
	 */
	public void expandArray()
	{	Object[] temp = new Object[2 * list.length];
		for(int i = 0; i < list.length; i++)
		{	temp[i] = list[i];
		}
		list = temp;
	}
}
