/**	Project: A1
 *	File: ListLinked.java
 *	Name: Justin Fiedler
 *	Login: fiedler
 */

public class ListLinked implements ListInterface
{	private ListNode first;
	private ListNode last;
	private int size;
	
	/**
	 * Constructs a default ListLinked by setting size = 0  and 
	 * first = null.
	 */
	public ListLinked()
	{	first = null;
		last = null;
		size = 0;
	}
	 
	/**
	 * Adds an object at the location given by position to the
	 * list, where the first item in the list is at position = 0. 
	 */
	public void add(int position, java.lang.Object ob)
	{	try
	    {	if(position < 0)
		{    throw new IndexOutOfBoundsException();
		}
		else if(position == 0)
		{	first = new ListNode(ob, first);
		}
		else
			{	ListNode curr = first;
				ListNode temp;
				for(int i = 0; i < position - 1; i++)
				{	curr = curr.next;
				}
				temp = new ListNode(ob,curr.next);
				curr.next = temp;
				if(position == size)
				{	last = temp;
				}
			}
			size++;
		}
		catch(NullPointerException e)
		{	throw new IndexOutOfBoundsException();
		}
	}

	/**
	 * Adds an object to the end of the list.
	 */
	public void add(java.lang.Object ob)
	{	if(first == null)
		{	first = last = new ListNode(ob);
		}
		else
		{	ListNode temp = new ListNode(ob);
		        last.next = temp;
			last = temp;
		}
		size++;
	}

	/**
	 * Returns the object at the given postion, where the first
	 * item in the list is at postion = 0.
	 */
	public java.lang.Object get(int position)
	{	Object o = null;
		try
		{	ListNode curr = first;
			for(int i = 0; i < position; i++)
			{	curr = curr.next;
			}
			o = curr.obj;
		}
		catch(NullPointerException e)
		{	throw new IndexOutOfBoundsException();
		}
		return o;		
	}

	/**
	 * Returns the object at position, after removing the object
	 * from the list.
	 */
	public java.lang.Object remove(int position)
	{	Object o = null;
		try
		{	if(position == 0)
			{	o = get(0);
				first = first.next;
			}
			else
			{	ListNode curr = first;
				for(int i = 0; i < position - 1; i++)
				{	curr = curr.next;
				}
				o = curr.next.obj;
				curr.next = curr.next.next;
			}
		}
		catch(NullPointerException e)
		{	throw new IndexOutOfBoundsException();
		}
		size--;
		return o;
	}

	/**
	 * Returns the number of items currently in the list.
	 */
	public int size()
	{	return size;
	}
}
